# Cubo Libre

Free software, open source hardware, secure computer.


# Overview

Cubo Libre is a Free Software, Open Source Hardware,
secure computer currently under development.


To have a secure computer, no part may be a "black box".
All software and hardware needs to be libre, so it can
be subject to audit and review.


Where any component falls short of being libre, it will
be documented and considered a critical bug.


To have a secure system, you need to have:

* Secure hardware.

* Secure firmware.

* Secure operating systems.

* Secure applications.


At present, nearly every computer system in the world fails
on all four counts above.


# Implementation
To achieve the above goals, best-of-class Free Software and
Open Source Hardware will be used. There is a paucity of
hardware at present, so best-of-class least-worst-component will
be used until a suitable replacement is found. Free Software /
Open Source Hardware will be prioritized over all other features.


The system will be designed to be secure from RF eavesdropping.


* Mini cluster workstation/server system.

* RISC-V Architecture for main systems.

* OpenBSD and GNU/Linux based operating systems.

* Strong emphasis on only libre firmware. Meticulous search for exceptions.

* Application vertical targeting secure blockchain computing.


# Hardware

See the `cubolibre-bom.ods` spreadsheet for hardware details.


## Main components

* 5x+ SiFive HiFive Unmatched RISC-V motherboards.

* Trellisboard FPGA PCBA.
![Trellisboard](pics/fs-trellisboard-front-sm.jpg)

* 12U RF/EMI secure cabinet.

* 2U rackmount cases.

* GPDI (General-Purpose Differential Interface) digital video out.

* RF/EMI secure keyboard, mouse, monitor.

* USB hardware firewalls.

* NVMe storage, clustered.

* 10G fiber out.

* Secure power in/out.

* External hardware time sync (GPS).

* Audio diodes for mic/speaker.

* Physical lockdown.

## Hardware Repositories

Source file `git` repositories:

* Cubo Libre Free Software, Open Source Hardware, secure computer.
https://code.forksand.com/forksand/cubolibre


* USB Hardware Firewall clone
https://code.forksand.com/forksand/usb-firewall

* Trellisboard
https://code.forksand.com/forksand/fs-TrellisBoard

* WASD Libre Open Source Hardware keyboard controller.
https://code.forksand.com/forksand/wasd-libre

Mirrors will be made of all upstream hardware used.


# Software

Overview of main software components. Acceptable licenses will follow
the Free Software Foundation's (FSF) list.

* https://www.gnu.org/licenses/license-list.html

Mirrors will be made of all upstream software used.


## Software Repositories

Source file repositories:

* https://code.forksand.com/forksand/cubolibre

* https://code.forksand.com/forksand/

* https://www.debian.org

* https://www.openbsd.org


# Prototype
Status.

* Bill of Materials (BOM) draft underway.

* Some components ordered.

* Component quoting underway.

* Prototype development is using the Microchip Icicle Kit RISC-V
ASIC and FPGA development board.

* Trellisboards have been manufactured and tested. A+. Need
component updates for supply chain.

* SiFive motherboard is "expected" to ship in March (2021).

* USB Hardware firewall clone manufactured.
![fs-usb-firewall-sm](pics/fs-usb-firewall-sm.jpg)

* Design of new USB hardware firewall underway in KiCAD.

* ULX3S, perchance.


![iditarod](pics/iditarod.jpg)
Similar in concept to this computer built in 2000 using PowerPC boards
for Terrasoft Solutions running Yellow Dog Linux. But more secure,
RF enclosed, RISC-V, etc.


![ULX3S](pics/fs-ulx3s-front-sm.jpg)
ULX3S Libre FPGA board.


![WASD-Libre](pics/wasd-libre-assembled.jpg)
* Libre keyboard controller, WASD Libre

